package de.hft.stuttgart.citydoctor2.gui.filter;

import de.hft.stuttgart.citydoctor2.datastructure.CityObject;
import de.hft.stuttgart.citydoctor2.datastructure.Geometry;

public abstract class ViewFilter {
	
	private boolean enabled = true;
	
	protected abstract boolean useGeometry(CityObject co, Geometry geom);
	
	public boolean allowedToUse(CityObject co, Geometry geom) {
		if (!enabled) {
			return false;
		}
		return useGeometry(co, geom);
	}
	
	public boolean isEnabled() {
		return enabled;
	}
	
	public void enable() {
		enabled = true;
	}
	
	public void disable() {
		enabled = false;
	}
	
	public void setEnable(boolean enabled) {
		this.enabled = enabled;
	}

}
